#ifndef INCLUDE_AVREGCONF_PERIODS_H
#define INCLUDE_AVREGCONF_PERIODS_H 1

#include <stdint.h>

#include <avregconf/common.h>

/* days */
extern const char *months_abbreviated[12];
const char *avregconf_month2abbrev(int mon);
int avregconf_abbrev2month(const char *mon_abbrev, int caseignore);

#define AVREGCONF_MAX_ALLDAYS  10
typedef struct avregconf_days_s {
   char     name[AVREGCONF_PARAMNAME_SZ];
   uint8_t  wdays;     /* each bit - dat if the week */
   uint32_t ydays[12]; /* each bit - day of the month, 12 - months in year, 0 - Jan */
} avregconf_days_t;

/* periods days [ timerange list ] { ... } */
typedef struct avregconf_periods_s {
   char     name[AVREGCONF_PARAMNAME_SZ];
   avregconf_days_t *days; /* days reference, NULL = alldays */
   uint64_t minutes[24];   /* each bit - minutes for each in 24 hours */
} avregconf_periods_t;


typedef avregconf_days_t *(* avregconf_find_days_cbk_t) (void *opaque, const char *days_name);
int avregconf_parse_days(void *opaque, const char *src, avregconf_days_t *days, avregconf_find_days_cbk_t find_days_cbk);

int
avregconf_parse_periods(void *opaque, const char *src, avregconf_find_days_cbk_t find_days_cbk, avregconf_periods_t *periods);

#endif // INCLUDE_AVREGCONF_PERIODS_H
